# -*- coding: utf-8 -*-

import _common

class Hero(object):

    def __init__(self):
        self.apis = [
            {
                'name': 'heroList',
                'desc': '获取英雄列表',
                'group': 'Hero',
                'url': 'webapp/index.php?c=Hero&a=heroList',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                    ['!hero_list', [_common.Hero()], '英雄列表']
                ]
            },
            {
                'name': 'skinList',
                'desc': '获取英雄皮肤列表',
                'group': 'Hero',
                'url': 'webapp/index.php?c=Hero&a=skinList',
                'params': [
                    _common.ReqHead(),
                ],
                'response': [
                    _common.RspHead(),
                    ['!skin_list', [_common.HeroSkin()], '英雄皮肤列表']
                ]
            },
            {
                'name': 'takeonSkin',
                'desc': '穿戴皮肤',
                'group': 'Hero',
                'url': 'webapp/index.php?c=Hero&a=takonSkin',
                'params': [
                    _common.ReqHead(),
                    ['hero_uniid', 0, '英雄唯一id'],
                    ['skin_id', 0, '皮肤id'],
                ],
                'response': [
                    _common.RspHead(),
                ]
            },
            {
                'name': 'upgradeSkill',
                'desc': '升技能',
                'group': 'Hero',
                'url': 'webapp/index.php?c=Hero&a=upgradeSkill',
                'params': [
                    _common.ReqHead(),
                    ['hero_uniid', 0, '英雄唯一id'],
                ],
                'response': [
                    _common.RspHead(),
                ]
            },
            {
                'name': 'upgradeLevel',
                'desc': '升等级',
                'group': 'Hero',
                'url': 'webapp/index.php?c=Hero&a=upgradeLevel',
                'params': [
                    _common.ReqHead(),
                    ['hero_uniid', 0, '英雄唯一id'],
                    ['cost_item_id', 0, '支付方式'],
                ],
                'response': [
                    _common.RspHead(),
                    ['property_chg', _common.PropertyChg(), '属性变更'],
                ]
            },
            {
                'name': 'upgradeQuality',
                'desc': '升阶',
                'group': 'Hero',
                'url': 'webapp/index.php?c=Hero&a=upgradeQuality',
                'params': [
                    _common.ReqHead(),
                    ['hero_uniid', 0, '英雄唯一id'],
                    ['cost_item_id', 0, '支付方式'],
                ],
                'response': [
                    _common.RspHead(),
                    ['property_chg', _common.PropertyChg(), '属性变更'],
                ]
            },
        ]
